﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace EditorRobobo
{
    public enum TipoCasilla
    {
        Vacia = 0,
        Pared,
        Ladron,
        Poli,
        Joya,
        Salida
    }
   public enum TipoMatriz { Mapa, Direcciones };
    public class Casilla
    {
        private TipoCasilla tipo;
        private Point pos;
        private Direcciones direccion;

        public Casilla()
        {
            this.pos = new Point(0, 0);
            this.tipo = TipoCasilla.Vacia;
            this.direccion = Direcciones.SinAsignar;
        }

        public Casilla(Casilla copia)
        {
            Constructor(copia.Posicion, copia.Tipo);
            this.direccion = copia.direccion;
        }

        public Casilla(Point posicion, TipoCasilla tipo)
        {
            Constructor(posicion, tipo);
        }

        public Casilla(Point posicion, char tipo)
        {
            TipoCasilla t = TipoCasilla.Vacia;
            switch (tipo)
            { 
                case 'W':
                    t = TipoCasilla.Pared;
                    break;
                case 'P':
                    t = TipoCasilla.Poli;
                    break;
                case 'L':
                    t = TipoCasilla.Ladron;
                    break;
                case 'J':
                    t = TipoCasilla.Joya;
                    break;
                case 'H':
                    t = TipoCasilla.Salida;
                    break;
            }

            Constructor(posicion, t);
        }

        private void Constructor(Point posicion, TipoCasilla tipo)
        {
            this.pos = new Point(posicion.X, posicion.Y);
            this.tipo = tipo;
            this.direccion = Direcciones.SinAsignar;
        }

        public Direcciones Direccion
        {
            get { return this.direccion; }
            set { this.direccion = value; }
        }

        public Point Posicion
        {
            get { return this.pos; }
        }

        public TipoCasilla Tipo
        {
            get { return this.tipo; }
            set { this.tipo = value; }
        }

        public string ToString(TipoMatriz t)
        {
            string s= " ";

            if (t == TipoMatriz.Mapa)
            {
                switch (this.tipo)
                {

                    case TipoCasilla.Pared:
                        s = "W";
                        break;
                    case TipoCasilla.Ladron:
                        s = "L";
                        break;
                    case TipoCasilla.Poli:
                        s = "P";
                        break;
                    case TipoCasilla.Joya:
                        s = "J";
                        break;
                    case TipoCasilla.Salida:
                        s = "H";
                        break;
                }
            }
            else
            {
                int temp = (int)this.direccion;
                s = temp.ToString();
            }
            return s;
        }
    }
}
