﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace EditorRobobo
{
    public partial class Form1 : Form
    {
        Mapa map = new Mapa(40, 22);
        Mapa haciajoya = new Mapa(40, 22);
        //Mapa haciajoya = new Mapa(40, 22);
        Point salida = new Point(0, 0);
        Point joya = new Point(0, 0);
        List<Point> polis = new List<Point>();
        List<Mapa> mapapolis = new List<Mapa>();

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (open.ShowDialog() == DialogResult.OK)
            {
                map = new Mapa(40, 22);
                polis = new List<Point>();
                mapapolis = new List<Mapa>();
                haciajoya = new Mapa(40, 22);

                StreamReader r = new StreamReader(open.FileName);
                for (int y = 0; y < 22; y++)
                {
                    string linea = r.ReadLine();
                    for (int x = 0; x < 40; x++)
                    {
                        char ch = linea[x];
                        switch (ch)
                        {
                            case 'S':
                                salida = new Point(x, y);
                                break;
                            case 'P':
                                polis.Add(new Point(x, y));
                                break;
                            case 'J':
                                joya = new Point(x, y);
                                break;

                        }

                        Casilla c = new Casilla(new Point(x, y), linea[x]);
                        map.setCasilla(x, y, c);
                        c = new Casilla(new Point(x, y), linea[x]);
                        haciajoya.setCasilla(x, y, c);
                        c = new Casilla(new Point(x, y), linea[x]);
                        haciajoya.setCasilla(x, y, c);
                    }
                }

                foreach (Point p in polis)
                {
                    Mapa m = new Mapa(map);
                    mapapolis.Add(map);
                }

                r.Close();
                AStar astar = new AStar(map);
                NodoAStar.Origen = new Point(3, 3);
                NodoAStar.Destino = new Point(3, 7);
                List<NodoAStar> sol = astar.AEstrella();
                foreach (NodoAStar n in sol)
                {
                    Casilla c = map.getCasilla(n.Posicion.X, n.Posicion.Y);
                    c.Direccion = n.Direccion;
                }
                guiMapa1.Map = map;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            
            NodoAStar.Destino = this.joya;
            haciajoya.ResetearDirecciones();
            for(int y=0;y<haciajoya.Size.Y;y++)
            {
                for(int x=0;x<haciajoya.Size.X;x++)
                {
                    Casilla cas = haciajoya.getCasilla(x, y);
                    if (cas.Tipo != TipoCasilla.Pared && cas.Direccion==Direcciones.SinAsignar)
                    {
                        NodoAStar.Origen = cas.Posicion;
                        AStar astar = new AStar(haciajoya);
                        List<NodoAStar> sol = astar.AEstrella();
                        foreach (NodoAStar n in sol)
                        {
                            Casilla c = haciajoya.getCasilla(n.Posicion.X, n.Posicion.Y);
                            c.Direccion = n.Direccion;
                        }
                    }
                }
            }
            
            guiMapa1.Map = haciajoya;


            for (int i = 0; i < polis.Count; i++)
            {
                NodoAStar.Destino = polis[i];
                mapapolis[i].ResetearDirecciones();
                for (int y = 0; y < mapapolis[i].Size.Y; y++)
                {
                    for (int x = 0; x < mapapolis[i].Size.X; x++)
                    {
                        Casilla cas = mapapolis[i].getCasilla(x, y);
                        if (cas.Tipo != TipoCasilla.Pared && cas.Direccion == Direcciones.SinAsignar)
                        {
                            NodoAStar.Origen = cas.Posicion;
                            AStar astar = new AStar(mapapolis[i]);
                            List<NodoAStar> sol = astar.AEstrella();
                            foreach (NodoAStar n in sol)
                            {
                                Casilla c = mapapolis[i].getCasilla(n.Posicion.X, n.Posicion.Y);
                                c.Direccion = n.Direccion;
                            }
                        }
                    }
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (save.ShowDialog()==DialogResult.OK)
            {
                StreamWriter w = new StreamWriter(save.FileName);

                // Mapa 40x22
                VolcarMatriz(map,w,TipoMatriz.Mapa);

                // A* de la joya
                VolcarMatriz(haciajoya, w, TipoMatriz.Direcciones);

                // Polis
                w.WriteLine(polis.Count.ToString());
                for(int i=0;i<polis.Count;i++)
                {
                    Point p=polis[i];
                    w.WriteLine(p.X);
                    w.WriteLine(p.Y);
                    VolcarMatriz(mapapolis[i],w,TipoMatriz.Direcciones);
                }
                w.Close();
            }
        }
      
        private void VolcarMatriz(Mapa mapa, StreamWriter w, TipoMatriz tipo)
        {
            for (int y = 0; y < mapa.Size.Y; y++)
            {
                string linea = "";
                for (int x = 0; x < mapa.Size.X; x++)
                {
                    linea += mapa.getCasilla(x, y).ToString(tipo) ;
                }
                w.WriteLine(linea);
            }
        }

    }
}
