﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace EditorRobobo
{
    public class Mapa
    {
        private Casilla[,] mapa;
        private int tamx, tamy;

        // Constructor de inicializacion
        public Mapa(int tamx, int tamy)
        {
            this.tamx = tamx;
            this.tamy = tamy;
            this.mapa = new Casilla[tamx, tamy];
        }

        // Constructor de copia
        public Mapa(Mapa copia)
        {
            this.tamy = copia.tamy;
            this.tamx = copia.tamx;
            this.mapa = new Casilla[tamx, tamy];
            for(int y=0;y<tamy;y++)
                for (int x = 0; x < tamx; x++)
                {
                    Casilla c = new Casilla(copia.mapa[x,y]);
                    this.mapa[x, y] = c;
                }
        }

        public Point Size
        {
            get { return new Point(this.tamx, this.tamy); }
        }

        public Casilla getCasilla(int x, int y)
        {
            return mapa[x,y];
        }

        public void setCasilla(int x, int y, Casilla c)
        {
            mapa[x, y] = c;
        }

        public void ResetearDirecciones()
        { 
            for(int y=0;y<tamy;y++)
                for (int x = 0; x < tamx; x++)
                    this.mapa[x,y].Direccion=Direcciones.SinAsignar;
        }
    }
}
