﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;

namespace EditorRobobo
{
    class NodoAStar
    {
        private static Point origen;
        private static Point destino;
        private float f;
        private float g;
        private NodoAStar padre;
        private Point posicion;
        private Direcciones direccion=Direcciones.SinAsignar;

        // Constructor
        public NodoAStar(NodoAStar padre, Point posicion, float coste)
        {
            this.padre = padre;
            this.posicion = posicion;
            float costeacumulado = 0;

            if (!this.EsRaiz())
                costeacumulado = padre.G;

            this.g = costeacumulado + coste;
            this.f = 0;
        }

        // Propiedades
        public static Point Origen
        {
            get { return origen; }
            set { origen = value; }
        }

        public static Point Destino
        {
            get { return destino; }
            set { destino = value; }
        }

        public Point Posicion
        {
            get { return this.posicion; }
        }

        public NodoAStar Padre
        {
            get { return padre; }
        }

        public float F
        {
            get { return this.f; }
        }

        public float G
        {
            get { return this.g; }
        }

        public Direcciones Direccion
        {
            get { return this.direccion; }
            set { this.direccion = value; }
        }

        public float H
        {
            get
            {
                float res = Math.Abs(destino.X - this.posicion.X) + Math.Abs(destino.Y - this.posicion.Y);
                this.f = g + res;
                return res;
            }
        }

        public bool EsRaiz()
        {
            return (this.padre == null);
        }

        public bool EsMeta()
        {
            if (this.posicion.X == destino.X && this.posicion.Y == destino.Y)
                return true;
            else
                return false;
        }

        public override bool Equals(object obj)
        {
            bool ret = false;
            NodoAStar aux = (NodoAStar)obj;
            if (this.posicion.X == aux.posicion.X && this.posicion.Y == aux.posicion.Y)//&& this.padre==aux.padre)
                ret = true;

            return ret;
        }

        public override int GetHashCode()
        {
            int hash = 5;
            hash = 89 * hash + (this.posicion != null ? this.posicion.GetHashCode() : 0);
            return hash;
        }
    }
}
